VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3030
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   3030
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1500
      Left            =   120
      Top             =   120
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   720
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      CommPort        =   6
      DTREnable       =   -1  'True
      OutBufferSize   =   1024
      RThreshold      =   1
      SThreshold      =   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


 
Sub Form_Load() ' this is the main thread
    'Set MSComm1 = CreateObject("MSCommlib.MScomm")

    Randomize Timer
    StopTOTimer
    MSComm1.CommPort = 6
    MSComm1.RThreshold = 1
    
    RC4KEY$ = ">4!1x4q3z4+7%4{9?5\3HhH^5$9=6@1~6,7_7|1)7'3]7[9:8<3*8S9I9l7Z1eT0r1"
    
    Preamble = 0                                ' using HC-12, preamble is not necessary else set to the length
                                                ' of the desired preamble (2+)
    
    GS = Chr$(&H1D)                             ' group seperator between checksum and packet
                                                ' check sum includes all the address, command and messsge data
    
    STX = Chr$(2)                               ' start of transmission
    ETX = Chr$(3)                               ' end of transmission
    
    Dim STXpos, ETXpos, GSpos, dst, src As Integer
    Dim Chk As Long
    Dim Cmd As String

    
    MSComm1.PortOpen = True
    

    
    ' main thread
    
    MSComm1Send 999, "INIT" & Time$ & "," & Date$ ' sync time of all modules
    MTSleep 5                                     ' wait for everything to boot
    
    Do
        MSComm1Send 999, "TIME" & Time$ & "," & Date$ ' sync time of all modules

        For Packet = 0 To 7 ' 0 is STAT (requires a response from attached devices
                            ' 1 - 3 is a POLL, devices only respond if they want to
                            ' both types can be used to pass back data to and from the slave
                            
             MTSleep 3      '  pause 3 seconds before commencing each cycle
            
            If Packet = 0 Then PType = "STAT" Else PType = "POLL"
               
            For Slave = 1 To 31 ' 998 is the highest slave address - discovery will take ~30 mins
                                    
                FlushRSBuff
                                
                SlaveMsg(Slave, 0) = "" ' 0=output
                
                ' make up some rubbish ----------------------------------
                                
                For nn = 1 To Rnd() * 100
                    SlaveMsg(Slave, 0) = SlaveMsg(Slave, 0) + Chr$(32 + (Rnd() * 62))
                Next
                
                'SlaveMsg(Slave,0) = String(115, "!")
                '----------------------------------
                
                If SlaveStatus(Slave) = 0 And Packet > 0 Then SlaveMsg(Slave, 0) = ""
                
                Debug.Print Slave; " "; SlaveMsg(Slave, 0)
                
                If (Packet = 0) Or (SlaveStatus(Slave) <> 0) Then

                    MSComm1Send Slave, PType & SlaveMsg(Slave, 0)
                    
PacketSend: ' re-entry point for additional POLLs

                    While (fgTO = False) And (FgETX = False)
                        Sleep 100
                        DoEvents
                    Wend
                    
                    StopTOTimer
                    
                    If fgTO = True And Packet = 0 Then
                        'if SlaveStatus(Slave) <> 0
                        SlaveStatus(Slave) = 0 ' must reply to STAT, no reply to POLL is ok
                    End If
            
                    If FgETX = True Then
                        SlaveStatus(Slave) = 1  ' mark as discovered device
                        'SlaveMsg(Slave, 1) = RSBuff ' 1=input message (from slave)
                        
                        Debug.Print SlaveMsg(Slave, 1)
                        
                        'process reply here
                        
                        STXpos = InStr(RSBuff, STX) ' find STX
                        If STXpos = 0 Then GoTo BadFrame
                        
                        GSpos = InStr(RSBuff, GS) ' find GS
                        If GSpos = 0 Then GoTo BadFrame
                        
                        ETXpos = InStr(RSBuff, ETX) 'find ETX
                        If ETXpos = 0 Then GoTo BadFrame
                        
                        If Not (STXpos < GSpos And GSpos < ETXpos) Then GoTo BadFrame ' in the right order?
                        
                        Chk = Val("&H" & Mid(RSBuff, STXpos + 1, 4)) ' extract the checksum
                        
                        A$ = Mid(RSBuff, GSpos + 1): RSBuff = "" ' ... and trim the packet
                        
                        A$ = Left(A$, InStr(A$, ETX) - 1) ' ...

                        If Int(Len(A$) / 2) <> Len(A$) / 2 Then GoTo BadFrame ' packet an even length?
                        
                        'A$ = UNRC4$(A$) ' decrypt the packet
                        A$ = DECRYPT$(A$) ' decrypt the packet
                        
                        For nn = 1 To Len(A$): Chk = Chk - Asc(Mid$(A$, nn, 1)): Next ' subtract each character from the checksum
                        
                        If Chk <> 0 Then GoTo BadFrame ' should be zero
                        
                        dst = Val(Left(A$, 3)): src = Val(Mid(A$, 4, 3)) ' extract the destination and source
                        
                        If (src <> Slave) Or dst <> 0 Then GoTo BadFrame ' is the reply from the same slave and to the master?
                        
                        'we have a good packet
                        
                        Cmd = Mid$(A$, 7, 4) ' extract the verb - it should only bee ACK0 or ACK1 from a slave
                        
                        SlaveMsg(Slave, 1) = SlaveMsg(Slave, 1) & Mid(A$, 11)  ' accumulate the payload
                        
                        Select Case Cmd
                        
                            Case "ACK0"
                                If Packet = 0 Then
                                    SlaveMsg(Slave, 2) = SlaveMsg(Slave, 1) ' store the info from a STAT
                                    Debug.Print Slave; "Discovered "; SlaveMsg(Slave, 2)
                                End If
                            Case "ACK1"
                                MTSleep 0.5
                                MSComm1Send Slave, "POLL"
                                GoTo PacketSend
                            Case Else
                                GoTo BadFrame

                        End Select
                        
                        ' response is complete
                        
                        
                        '-------------------------------------------------------
                        ' process the slave data here
                        
                        

                        
                        '-------------------------------------------------------
                        
                        
BadFrame:
                        SlaveMsg(Slave, 0) = "": SlaveMsg(Slave, 1) = ""
                    End If
                    
                    
        
                End If
        
            Next Slave
        Next Packet
        MTSleep 1.5
    Loop
    
    
    
    
End Sub
Private Sub FlushRSBuff()

    Do While MSComm1.InBufferCount <> 0
        Sleep 250
        RSBuff = MSComm1.Input
    Loop
    
    RSBuff = ""

End Sub








Private Sub MSComm1_OnComm()  ' triggers when chars recieved from MSComm1
    Dim x As String
    If MSComm1.CommEvent = comEvReceive Then
        
        Do
            Sleep 250
            x = MSComm1.Input
            RSBuff = RSBuff & x  ' gradually build up the response string in the buffer
        Loop Until MSComm1.InBufferCount = 0
        

        
        If InStr(RSBuff, ETX) Then
            FgETX = True: StopTOTimer ' if we get a ETX then we have data in the buffer
            ' so signal to the main thread
        End If
        
    End If
End Sub



Private Sub Timer1_Timer() ' the time-out timer
    Timer1.Enabled = False
    fgTO = True
End Sub

Private Sub StartTOTimer()
    fgTO = False: FgETX = False
    Timer1.Interval = 1500 ' default time to wait for response
    Timer1.Enabled = True
End Sub

Private Sub StopTOTimer() ' stop the TO timer - used to cancel a timeout period and at startup
    Timer1.Enabled = False
End Sub

Private Sub MSComm1Send(ByVal dest As Integer, ByVal msg As String)
    ' dest is 1-998. 999 is brodcast but the mechanism is the same
    ' the packet looks like STX-checksum-GS-RC4(packet)-ETX
    
    Dim qq As String
    Dim Chk As Long
    
    'qq = RC4$(ZPad(dest) & "000" & msg) ' the dest and src are included in the RC4
    qq = ENCRYPT$(ZPad(dest) & "000" & msg) ' the dest and src are included in the RC4
    
    For m = 1 To Len(qq) ' calculate checksum of the entire RC4ed packet between GS and ETX
        Chk = Chk + Asc(Mid(qq, m, 1))
    Next
    
    qq = STX & Right("0000" & Hex$(Chk), 4) & GS & qq & ETX

    MSComm1.Output = String$(Preamble, Chr$(&HFE)) & qq
    
    RSBuff = ""
    
    Sleep Len(qq) + 250 '  wait for the packet to go, ~1mS per char at 9600 baud + min packet processing speed of slaves @48MHz
    
    StartTOTimer
    
    DoEvents

End Sub


Private Function ZPad(x) As String
    ZPad = Right("000" + Mid(Str$(x), 2), 3)
End Function

    Function ENCRYPT$(A$)
        Dim N As Integer, P As Integer
        Dim B$
        P = 1
        For N = 1 To Len(A$)
            B$ = B$ & Right("0" & Hex((Asc(Mid(A$, N, 1))) Xor (Asc(Mid(RC4KEY$, P, 1)))), 2)
            P = P + 1: If P > Len(RC4KEY$) Then P = 1
        Next
        ENCRYPT$ = B$
    End Function


    Function DECRYPT$(A$)
        Dim N As Integer, P As Integer
        Dim B$
        P = 1
        For N = 1 To Len(A$) Step 2
            B$ = B$ + Chr$(Val("&H" + Mid$(A$, N, 2)) Xor Asc(Mid$(RC4KEY$, P, 1)))
            P = P + 1: If P > Len(RC4KEY$) Then P = 1
        Next
        DECRYPT$ = B$
    End Function
    

Sub MTSleep(sec As Single)
    Dim nn As Long
    For nn = 1 To CLng(sec * 100): Sleep 10: DoEvents: Next
End Sub
